/*
 * (C) Copyright 2011
 * CompuLab, Ltd., <www.compulab.co.il>
 * Ilya Ledvich <ilya@compulab.co.il>
 * Igor Grinberg <grinberg@compulab.co.il>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc.
 */

#include <common.h>
#include <asm/arch/mux.h>

#include "common.h"
#include "mux.h"

/**********************************************************************
 * All functions below use the following semantics:
 * IEN  - Input Enable
 * IDIS - Input Disable
 * PTD  - Pull type Down
 * PTU  - Pull type Up
 * DIS  - Pull type selection is inactive
 * EN   - Pull type selection is active
 * M0   - Mode 0
 **********************************************************************/

void set_sdrc_muxconf_regs(void)
{
	MUX_VAL(CP(SDRC_D0),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D1),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D2),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D3),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D4),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D5),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D6),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D7),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D8),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D9),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D10),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D11),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D12),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D13),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D14),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D15),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D16),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D17),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D18),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D19),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D20),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D21),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D22),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D23),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D24),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D25),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D26),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D27),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D28),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D29),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D30),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_D31),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_CLK),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_DQS0),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_DQS1),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_DQS2),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(SDRC_DQS3),	(IEN  | PTD | DIS | M0));
}

void set_gpmc_muxconf_regs(void)
{
	MUX_VAL(CP(GPMC_A1),		(IDIS | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_A2),		(IDIS | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_A3),		(IDIS | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_A4),		(IDIS | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_A5),		(IDIS | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_A6),		(IDIS | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_A7),		(IDIS | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_A8),		(IDIS | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_A9),		(IDIS | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_A10),		(IDIS | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_D0),		(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_D1),		(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_D2),		(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_D3),		(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_D4),		(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_D5),		(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_D6),		(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_D7),		(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_D8),		(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_D9),		(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_D10),		(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_D11),		(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_D12),		(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_D13),		(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_D14),		(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_D15),		(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_CLK),		(IDIS | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_nADV_ALE),	(IDIS | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_nOE),		(IDIS | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_nWE),		(IDIS | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_nBE0_CLE),	(IDIS | PTD | DIS | M0));
	MUX_VAL(CP(GPMC_nWP),		(IEN  | PTD | DIS | M0));
}

void set_jtag_muxconf_regs(void)
{
	MUX_VAL(CP(JTAG_nTRST),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(JTAG_TCK),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(JTAG_TMS),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(JTAG_TDI),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(JTAG_EMU0),	(IEN  | PTD | DIS | M0));
	MUX_VAL(CP(JTAG_EMU1),	(IEN  | PTD | DIS | M0));
}

